﻿using System;
using System.ComponentModel;
using System.Runtime.CompilerServices;

namespace KB2185_XamTreeGrid_ExpandNodesByHandlingEvent.Infrastructure
{
    public abstract class ObservableObject : INotifyPropertyChanged
    {
        protected ObservableObject()
        {

        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] String propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

    }
}
